#include "stdafx.h"
#include "nTalkUploadFileJob.h"

CNTalkUploadFileJob::CNTalkUploadFileJob(const CAtlString& strAgent, BOOL bSuspendOnCreate)
:CFUploadJob(strAgent, bSuspendOnCreate)
{

}

CNTalkUploadFileJob::~CNTalkUploadFileJob()
{

}

BOOL CNTalkUploadFileJob::_SendCallbackParam(PBYTE pBuffer, DWORD dwBufferSize)
{
	FUNCTION_BLOCK_TRACE(100);
	BOOL bRet = TRUE;
	//DWORD dwPostSize = 0;

	//PBYTE pDestBuffer = pBuffer;
	//DWORD dwDestSize = 0;

	for (TransferParamContainer::iterator iter = m_JobParam->m_transferParams.begin();
		iter != m_JobParam->m_transferParams.end();
		++iter)
	{
		FTransferParam& transParam = *iter;
		if (transParam.paramType == tptPostArgument && transParam.transferOrder == toNeedCallback)
		{
			FTLASSERT(transParam.strName == TEXT("ticket"));

			CString strTicket= String2CString(g_pMessengerActor->GetMessengerTicket());
			strTicket.Replace(_T("%3D%3D"), _T("=="));

			CAtlStringA strParam;
			strParam.Format(
				"--%s\r\n"
				"Content-Disposition: form-data; name=\"%s\"\r\n"
				"\r\n"
				"%s\r\n", 
				CFConversion(transParam.CodePage).TCHAR_TO_UTF8(_GetMultiPartBoundary(FALSE)),
				CFConversion(transParam.CodePage).TCHAR_TO_UTF8(transParam.strName),
				CFConversion(transParam.CodePage).TCHAR_TO_UTF8(strTicket)
			);
			
			DWORD dwDestSize = strParam.GetLength();
			API_VERIFY(_Write((PBYTE)(LPCSTR)strParam, dwDestSize, NULL));
			//API_VERIFY(_SendN((PBYTE)(LPCSTR)strParam, dwDestSize, NULL));
			m_nCurPos += dwDestSize;
			_NotifyProgress(m_nCurPos, m_nTotalSize);
		}
	}
	if (!bRet)
	{
		_SetErrorStatus(GetLastError(), TEXT("_SendCallbackParam"));
	}
	return bRet;
}